#include <bits/stdc++.h>

#define F first
#define S second

using namespace std;
using ll = long long;
using pii= pair<int, int>;

const int N = 5e5+7;
const int INF = 1e9;

int n, k, pos[N], h[N], ch[N], m;
struct SegmentTree {
    int* sgt, n;

    SegmentTree() : n(0), sgt(nullptr) { }

    SegmentTree(int n) : n(n) {
        sgt = new int[4*n];
    }

    void bld(int v, int vl, int vr, int* h) {
        if(vl == vr) sgt[v] = h[vr];
        else {
            int vm = (vl+vr)/2;
            bld(2*v+1, vl, vm, h);
            bld(2*v+2, vm+1, vr, h);
            sgt[v] = min(sgt[2*v+1], sgt[2*v+2]);
        }
    }

    int rmq(int v, int vl, int vr, int l, int r) {
        if(vl >= l && vr <= r) return sgt[v];
        if(vl >  r || vr <  l) return INF;

        int vm = (vl+vr)/2;
        return min(rmq(2*v+1, vl, vm, l, r), rmq(2*v+2, vm+1, vr, l, r));
    }
} sgt;

int calc_flower(int i, int k) {
    int l = ((i-k)%n+n)%n, r = (i+k)%n;
    l = pos[l], r = pos[r];
    if(n%2) {
        if(k >= n/2) return sgt.rmq(0, 0, n-1, 0, n-1);
    }
    else {
        if(k >= n/4) {
            if(l >= n/2 && r >= n/2) return sgt.rmq(0, 0, n-1, n/2, n-1);
            if(l <  n/2 && r <  n/2) return sgt.rmq(0, 0, n-1, 0, n/2-1);
        }
    }
    if(l < r) return sgt.rmq(0, 0, n-1, l, r);
    if(n%2) return min(sgt.rmq(0, 0, n-1, 0, l), sgt.rmq(0, 0, n-1, r, n-1));
    if(l >= n/2 && r >= n/2) return min(sgt.rmq(0, 0, n-1, n/2, r), sgt.rmq(0, 0, n-1, l, n-1));
    if(l <  n/2 && r <  n/2) return min(sgt.rmq(0, 0, n-1, 0, r), sgt.rmq(0, 0, n-1, l, n/2-1));
    return -1;
}

int main() {
    cin >> n >> k;
    for(int i = 0; i < n; ++i) cin >> h[i];
    for(int i = 0; i < n && m != n; i += 2) ch[pos[i] = m++] = h[i];
    for(int i = 1; i < n && m != n; i += 2) ch[pos[i] = m++] = h[i];
    sgt = SegmentTree(n); sgt.bld(0, 0, n-1, ch);
    for(int i = 0; i < n; ++i) {
        cout << calc_flower(i, k) << ' ';
    }
}
