#include <bits/stdc++.h>

#define F first
#define S second

using namespace std;
using ll = long long;
using pii= pair<int, int>;

const int INF = 1e9;

stack<string> objects;
stack<int> call_stack, func_obj;
map<string, int> func;

struct Action {
    int type; // 0 sign, 1 - create obj, 2 - throw, 3 - call, 4, return
    string obj;

    Action(int t) : type(t), obj() { }
    Action(int t, string s) : type(t), obj(s) { }
};

vector<Action> parse() {
    vector<Action> prg;
    string w, t, u;
    while(cin >> w) {
        if(w == "void") {
            cin >> t >> u;
            prg.push_back(Action(0)); // nop
            func[t] = prg.size() - 1;
        }
        else if(w[w.size()-1] == ')' && w[w.size()-2] == '(') {
            prg.push_back(Action(3, w));
        }
        else if(w == "throw") {
            prg.push_back(Action(2));
        }
        else if(w == "}") {
            prg.push_back(Action(4));
        }
        else {
            cin >> t;
            prg.push_back(Action(1, w));
        }
    }
    return prg;
}

int main() {
    vector<Action> prg = parse();
    call_stack.push(0);
    func_obj.push(0);
    for(int pos = func["main()"]; !call_stack.empty();) {
        if(prg[pos].type == 1) {
            cout << prg[pos].obj << "()" << endl;
            func_obj.top()++;
            objects.push(prg[pos].obj);
        }
        if(prg[pos].type == 2) {
            cout << "throw" << endl;
            break;
        }
        if(prg[pos].type == 4) {
            while(func_obj.top()--) {
                cout << "~" << objects.top() << "()" << endl;
                objects.pop();
            }

            call_stack.pop();
            func_obj.pop();

            if(!call_stack.empty()) {
                pos = call_stack.top();
            }
            continue;
        }
        if(prg[pos].type == 3) {
            call_stack.top() = pos + 1;
            pos = func[prg[pos].obj];
            func_obj.push(0);
            call_stack.push(pos);
        }
        ++pos;
    }

    while(!objects.empty()) {
            cout << "~" << objects.top() << "()" << endl;
        objects.pop();
    }
}
